
{ͻ }
{ 뢠 COM 䠩   EXE.       }
{ࠡ稪 : DASAEV Corp.              }
{ CopyRight(c) 29.12.95                  }
{  COM : DOP.ASM                   }
{ͼ }

USES   	DOS,CRT;

TYPE
  TEXEHeader = RECORD
		Signature : WORD;
		PartPag   : WORD;
		FileSize  : WORD;
		RelCnt    : WORD;
                HdrSize   : WORD;
                MinAlloc  : WORD;
                MaxAlloc  : WORD;
                SS0       : WORD;
                SP0       : WORD;
                CheckSum  : WORD;
                IP0       : WORD;
                CS0       : WORD;
                RelOfs    : WORD;
                Ovl       : WORD;
               END;
  TCOMfile = Array[0..32000] Of Word;

VAR
  FName         : String;
  DopName       : String;
  DopLen        : WORD;
  Dop           : ^TCOMfile;
  ExeHnd,ComHnd : FILE;
  EXEHdr        : TEXEHeader;
  SaveExitProc  : Pointer;


Procedure Error(S : String);
Begin
 Sound(400);Delay(50);NoSound;
 WriteLn(S);
 ExitProc := SaveExitProc;
 Halt;
End;

Procedure Syntax;
Begin
 TextAttr := $0F;

 WriteLn('');
 WriteLn('ͻ');
 WriteLn('WR2EXE 뢠⥫ COM 䠩  EXE.');
 WriteLn('ͻDASAEV Corp.(c) 1995 ͼ');
 WriteLn('     ͼ');
 TextAttr := $03;
 WriteLn;
 WriteLn('  USE : WR2EXE[.EXE] DEST.EXE SOURCE.COM  ');
 TextAttr := $07;
 WriteLn;
 Halt;
End;

Procedure InitEXEFile(S : String);
Var
 L,L2 : LongInt;
Begin
 Assign(ExeHnd,S);
 Reset(ExeHnd,1);
 BlockRead(ExeHnd,EXEHdr,SizeOf(TEXEHeader));
 If EXEHdr.Signature <> $5A4D Then
  Error('  EXE - 䠩!');
 L := FileSize(ExeHnd);
 L2 := ((LongInt(EXEHdr.FileSize)- 1) * 512) + LongInt(EXEHdr.PartPag);
 If( L <> L2)
 Then
  Error('  EXE - 䠩   ଠ!');
End;

Procedure InitCOMFile(S : String);
Begin
 Assign(ComHnd,S);
 Reset(ComHnd,1);
 DopLen := FileSize(ComHnd);
 If DopLen > $FFFE Then
  Error('誮  COM - 䠩!');
End;

Procedure WriteToEnd;
VAR
 ComSize : WORD;
 L2,L    : LongInt;
Begin
 GetMem(Dop,DopLen);
 If Dop = Nil Then
  Error('訡 뤥 !');
 BlockRead(ComHnd,Dop^,DopLen);

 Dop^[2] := ExeHdr.IP0;
 Dop^[3] := ExeHdr.CS0;

 L := LongInt(ExeHdr.PartPag) + (LongInt(ExeHdr.FileSize) - 1) * 512;
 L := (L - ExeHdr.HdrSize * 16) And $FFFFFFF0 + $10;

 ExeHdr.CS0 := WORD(L Div $10);
 ExeHdr.IP0 := 0;
 L2 := L;
 L  := L + DopLen + ExeHdr.HdrSize * 16;
 ExeHdr.FileSize := WORD(L Div 512 + 1);
 ExeHdr.PartPag  := WORD(L Mod 512);
 Seek(ExeHnd,0);
 BlockWrite(ExeHnd,ExeHdr,SizeOf(TEXEHeader));
 Seek(ExeHnd,L2 + LongInt(ExeHdr.HdrSize) * 16);
 BlockWrite(ExeHnd,Dop^,DopLen);
End;

Procedure CloseFiles;
Begin
 Close(ComHnd);
 Close(ExeHnd);
 WriteLn;
 WriteLn(' ',DopName,' ᠭ  䠩 ',FName,' !');
 WriteLn;
End;


Procedure Up(VAR S : ExtStr);
Var
  I : Byte;
Begin
 For I:=1 to Ord(S[0]) Do
  S[I] := UpCase(S[I]);
End;

Procedure CheckNames;
Var
 S : DirStr;
 D : NameStr;
 E : ExtStr;
Begin
 FSplit(FName,S,D,E);
 Up(E);
 If E <> '.EXE' Then
  Error(' 䠩   EXE.');
 FSplit(DopName,S,D,E);
 Up(E);
 If E <> '.COM' Then
  Error('ன 䠩   COM.');
End;

Procedure MyErrorProc;
Begin
 Error(' : ந諠 - 訡!');
End;

BEGIN
 If ParamCount < 2 then Syntax;
 FName   := ParamStr(1);
 DopName := ParamStr(2);
 CheckNames;

 SaveExitProc := ExitProc;
 ExitProc     := @MyErrorProc;

 InitEXEFile(FName);
 InitCOMFile(DopName);
 WriteToEnd;
 CloseFiles;

 ExitProc := SaveExitProc;

END.
